/*******************************************************************************
*                                                                              *
*	SXUPTP sample program                                                      *
*                                                                              *
*   silex technology, Inc. CONFIDENTIAL                                        *
*                                                                              *
*----------+---------+---------------------------------------------------------*
*   Date   | Version |                        Content                          *
*----------+---------+---------------------------------------------------------*
* 07-01-15 |  1.0.0  |                                                         *
*----------+---------+---------------------------------------------------------*
*******************************************************************************/
#include <winsock2.h>
#include <ws2tcpip.h>
#include <windows.h>
#include <windowsx.h>
#include <winioctl.h>
#include <iphlpapi.h>
#include <tchar.h>

#include "sxuptp.h"
#include "sample.h"


/*----------------------------------------------------------------------------*/
/*		Constant definition                                                   */
/*----------------------------------------------------------------------------*/
#define MAX_PSERVER			16
#define MAX_DEVICE			64

#define STATUS_AVAILABLE	1
#define STATUS_CONNECTED	2
#define STATUS_INUSE		3
#define STATUS_NOTFOUND		4

#define SVLC_ENCRYPT		0x0001 
#define SVLC_AUTH			0x0004 


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
typedef struct _SXUSBDEVINFO {
	char	szPortName[5120];				// ex: dev01,dev02,dev03
	TCHAR	szDeviceName[SXUPTP_DEVICE];
	DWORD	dwIpPc;
	BYTE	bIpAddrPc[16];
	WORD	wStatus;
	WORD	wVid;
	WORD	wPid;
	char	szLocation[3072];				// ex: M112M0,M112M1,M112M2
	WORD	wClass;
} SXUSBDEVINFO, *LPSXUSBDEVINFO;


/*----------------------------------------------------------------------------*/
/*		Variable definition                                                   */
/*----------------------------------------------------------------------------*/
SXPSERVER		gsxsrv[MAX_PSERVER];
SXUSBDEVINFO	gsxdev[MAX_DEVICE];

SRUINFO			gSruInfo;
HWND			ghMsgWnd = NULL;
char			gszPassword[SXUPTP_PASSWORD+1];


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
#define get_word(src)		(*((WORD*)(src)))
#define get_dword(src)		(*((DWORD*)(src)))
#define set_word(dst, val)	(*((WORD*)(dst)) = (WORD)(val))
#define set_dword(dst, val)	(*((DWORD*)(dst)) = (DWORD)(val))


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static VOID GetCurDir(LPSTR lpszPath)
{
	DWORD	dwSize;
	TCHAR	szBuf[MAX_PATH];
	WCHAR	szwBuf[MAX_PATH];
	int		i;

	if (lpszPath == NULL)	return;

	GetModuleFileName(NULL, szBuf, sizeof(szBuf));
	dwSize = MultiByteToWideChar(GetOEMCP(), 0, szBuf, -1, szwBuf, sizeof(szwBuf)) - 1;

	for (i = dwSize - 1; i > 0; i --)
	{
		if (szwBuf[i] == '\\')
		{
			szwBuf[i] = '\0';
			break;
		}
	}

	WideCharToMultiByte(GetOEMCP(), 0, szwBuf, -1, szBuf, sizeof(szBuf), NULL, NULL);
	lstrcpy(lpszPath, szBuf);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static BOOL In6AddrIsZero(LPBYTE lpbIpAddr6)
{
	int	i;

	for (i = 0; i < 16; i++) {
		if (lpbIpAddr6[i] != 0)	return (FALSE);
	}

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static BOOL CollectMfpInterface(
	LPSXUSBDEVINFO	lpdvif1,
	LPSXUSBDEVINFO	lpdvif2,
	int				nCount
)
{
	LPSTR	p;
	TCHAR	szBuf1[4096], szBuf2[4096];
	int	    i;

	if ((lpdvif1 == NULL) || (lpdvif2 == NULL)) return (FALSE);

	lstrcpy(szBuf1, lpdvif1->szLocation);
	if ((p = strstr(szBuf1, "M")) == NULL) return (FALSE);
	*p = '\0';

	for (i = 0; i < nCount; i++)
	{
		lstrcpy(szBuf2, (lpdvif2 + i)->szLocation);
		if ((p = strstr(szBuf2, "M")) == NULL)	continue;
		*p = '\0';

		if (!lstrcmp(szBuf1, szBuf2) &&
			lpdvif1->wPid == (lpdvif2 + i)->wPid && lpdvif1->wVid == (lpdvif2 + i)->wVid)
		{
			lstrcat((lpdvif2 + i)->szPortName, ",");
			lstrcat((lpdvif2 + i)->szPortName, lpdvif1->szPortName);

			lstrcat((lpdvif2 + i)->szLocation, ",");
			lstrcat((lpdvif2 + i)->szLocation, lpdvif1->szLocation);

			if (lpdvif1->dwIpPc > 0)
				(lpdvif2 + i)->dwIpPc = lpdvif1->dwIpPc;
			if (!In6AddrIsZero(lpdvif1->bIpAddrPc))
				memcpy((lpdvif2 + i)->bIpAddrPc, lpdvif1->bIpAddrPc, 16);

			return (TRUE);
		}
	}

	return (FALSE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static int GetDevString(
	LPSTR	lpszString1,
	LPSTR	lpszString2
)
{
	int	i;

	for (i = 0; ; i++)
	{
		if (*(lpszString2 + i) == ',' || *(lpszString2 + i) == '\0')	break;
		*(lpszString1 + i) = *(lpszString2 + i);
	}
	*(lpszString1 + i) = '\0';

	if (*(lpszString2 + i) == '\0')	return (i);
	else							return (i + 1);

}


/*-----------------------------------------------------------------------------*/
/*		                                                                       */
/*-----------------------------------------------------------------------------*/
LONG GetHostIdEx(DWORD dwIpAdder)
{
	SOCKADDR_IN	stLclAddr;
	SOCKADDR_IN	stRmtAddr;
	HOSTENT		*lpHost;
	IN_ADDR		inaddr;
	SOCKET		hSock;
	char		szBuf[MAX_PATH];
	int			nAddrSize = sizeof(SOCKADDR);
	int			nRet, i, iCount;

	ZeroMemory(&stLclAddr, sizeof(SOCKADDR_IN));
	ZeroMemory(&stRmtAddr, sizeof(SOCKADDR_IN));
	stLclAddr.sin_addr.s_addr = INADDR_ANY;
	iCount = 0;

	nRet = gethostname(szBuf, (int)sizeof(szBuf));
	if (nRet == SOCKET_ERROR)	return (stLclAddr.sin_addr.s_addr);

	lpHost = gethostbyname(szBuf);
	for (i = 0; lpHost->h_addr_list[i]; i++)
	{
		memcpy(&inaddr, lpHost->h_addr_list[i], 4);
		stLclAddr.sin_addr.s_addr = inaddr.s_addr;
	}

	if (i <= 1) return (stLclAddr.sin_addr.s_addr);

	hSock = socket(AF_INET, SOCK_DGRAM, 0);
	if (hSock != INVALID_SOCKET)
	{
		stRmtAddr.sin_family = AF_INET;
		stRmtAddr.sin_port = htons(IPPORT_ECHO);
		stRmtAddr.sin_addr.s_addr = dwIpAdder;
		nRet = connect(hSock, (LPSOCKADDR)&stRmtAddr, sizeof(SOCKADDR));
		if (nRet != SOCKET_ERROR)
			getsockname(hSock, (LPSOCKADDR)&stLclAddr, (int FAR *)&nAddrSize);
		closesocket(hSock);
	}

	return (stLclAddr.sin_addr.s_addr);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static BOOL IsConnected(
	LPBYTE	lpbIpAddr,
	int		iFamily
)
{
	PIP_ADAPTER_ADDRESSES		pAdapter0, pAdapter;
	PIP_ADAPTER_UNICAST_ADDRESS pUnicast;
	DWORD						dwSize;
	BOOL						bResult = FALSE;

	dwSize = 0;
	if (GetAdaptersAddresses(iFamily, 0, 0, 0, &dwSize) != ERROR_BUFFER_OVERFLOW)	return (FALSE);

	pAdapter0 = (PIP_ADAPTER_ADDRESSES)GlobalAlloc(GPTR, dwSize);
	if (pAdapter0 == NULL)	return (FALSE);
	GetAdaptersAddresses(iFamily, 0, 0, pAdapter0, &dwSize);

	pAdapter = pAdapter0;

	while (pAdapter != NULL)
	{
		if (pAdapter->PhysicalAddressLength != 6)
		{
			pAdapter = pAdapter->Next;
			continue;
		}

		pUnicast = pAdapter->FirstUnicastAddress;
		while (pUnicast)
        {
			if (pUnicast->Address.lpSockaddr->sa_family == AF_INET)
            {
				LPSOCKADDR_IN	pSock4 = (LPSOCKADDR_IN)pUnicast->Address.lpSockaddr;

				if (get_dword(lpbIpAddr) == pSock4->sin_addr.s_addr)
				{
					bResult = TRUE;
					goto EXIT;
				}
			}
			else if (pUnicast->Address.lpSockaddr->sa_family == AF_INET6)
			{
				LPSOCKADDR_IN6	pSock6 = (LPSOCKADDR_IN6)pUnicast->Address.lpSockaddr;

				if (!memcmp(pSock6->sin6_addr.s6_addr, lpbIpAddr, 16))
				{
					bResult = TRUE;
					goto EXIT;
				}
			}
			pUnicast = pUnicast->Next;
		}

		pAdapter = pAdapter->Next;
	}

EXIT:
	GlobalFree(pAdapter0);

	return (bResult);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static WORD ConvConnectStatus(
	LPSXUSBDEVINFO	lpsxdev
)
{

	if ((lpsxdev->wStatus & 0x0001) == 0)	return (STATUS_NOTFOUND);

	if (lpsxdev->dwIpPc == 0 && In6AddrIsZero(lpsxdev->bIpAddrPc))
		return (STATUS_AVAILABLE);

	if (lpsxdev->dwIpPc != 0)
	{
		if (IsConnected((LPBYTE)&lpsxdev->dwIpPc, AF_INET))
			return (STATUS_CONNECTED);
	}

	if (!In6AddrIsZero(lpsxdev->bIpAddrPc))
	{
		if (IsConnected(lpsxdev->bIpAddrPc, AF_INET6))
			return (STATUS_CONNECTED);
	}

	return (STATUS_INUSE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static int CompareDevice(
	LPSXUSBDEVINFO	lpsxdev1,
	LPSXUSBDEVINFO	lpsxdev2,
	DWORD			dwDevCount
)
{
	DWORD	i;
	TCHAR	szLocation1[16], szLocation2[16];

	for (i = 0; i < dwDevCount; i++)
	{
		GetDevString(szLocation1, lpsxdev1->szLocation);
		GetDevString(szLocation2, (lpsxdev2 + i)->szLocation);

		if (lstrcmp(lpsxdev1->szDeviceName, (lpsxdev2 + i)->szDeviceName))	continue;
		if (lstrcmp(szLocation1, szLocation2))								continue;
		if (lpsxdev1->wPid != (lpsxdev2 + i)->wPid)	continue;
		if (lpsxdev1->wVid != (lpsxdev2 + i)->wVid)	continue;
		return (i);
	}

	return (-1);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static BOOL MyAddressToString(
	LPTSTR	lpszString,
	DWORD	dwSize,
	LPBYTE	lpbAddress,
	int		iAddrlen
)
{
	SOCKADDR_STORAGE	sa;
	DWORD				dwAddrLen = dwSize;
	int					iSocklen = 0;

	ZeroMemory(&sa, sizeof(sa));

	if (iAddrlen == 4)
	{
		LPSOCKADDR_IN	sa4 = (LPSOCKADDR_IN)&sa;

		sa4->sin_addr.s_addr = get_dword(lpbAddress);
		sa4->sin_family = AF_INET;
		iSocklen = sizeof(SOCKADDR_IN);
	}
	else if (iAddrlen == 16)
	{
		LPSOCKADDR_IN6	sa6 = (LPSOCKADDR_IN6)&sa;

		memcpy(sa6->sin6_addr.s6_addr, lpbAddress, 16);
		sa6->sin6_family = AF_INET6;
		iSocklen = sizeof(SOCKADDR_IN6);
	}

	if (WSAAddressToString((LPSOCKADDR)&sa,
		iSocklen, NULL, lpszString, &dwAddrLen) == SOCKET_ERROR)
	{
		return (FALSE);
	}

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Serial server searching function                                      */
/*----------------------------------------------------------------------------*/
static BOOL OnClickSearch(HWND hDlg)
{
	HWND	hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD	i, dwReaded, dwReturned;
	TCHAR	szBuf[256], szIp[16], szAddr[64], szMac[32];
	int		iCount = ListBox_GetCount(hPrList);

	ZeroMemory(gsxsrv, (sizeof(SXPSERVER) * MAX_PSERVER));
	ListBox_ResetContent(hPrList);
	ListBox_ResetContent(GetDlgItem(hDlg, IDC_LIST_DEVICE));

#if 0
	DWORD	dwIp[16];
	dwIp[0] = inet_addr("192.168.30.255");
	dwIp[1] = inet_addr("192.168.40.255");
#endif

	if (SxuptpEnumDeviceServers(NULL, 0, &gsxsrv,
		(sizeof(SXPSERVER) * MAX_PSERVER), &dwReaded, &dwReturned) == FALSE)
	{
		return (FALSE);
	}

	for (i = 0; i < dwReturned; i++)
	{
		MyAddressToString(szIp, _countof(szIp), (LPBYTE)&gsxsrv[i].dwIp, 4);
		MyAddressToString(szAddr, _countof(szAddr), gsxsrv[i].bIpAddress, 16);

		wsprintf(szMac, "%02X:%02X:%02X:%02X:%02X:%02X",
			gsxsrv[i].bNodeaddr[0], gsxsrv[i].bNodeaddr[1],
			gsxsrv[i].bNodeaddr[2], gsxsrv[i].bNodeaddr[3],
			gsxsrv[i].bNodeaddr[4], gsxsrv[i].bNodeaddr[5]
		);
		wsprintf(szBuf, "%s (%s / %s / %s / %s)",
			gsxsrv[i].szMachineType, szIp, szAddr, gsxsrv[i].szHostName, szMac);
		ListBox_AddString(hPrList, szBuf);
	}

	ListBox_SetHorizontalExtent(hPrList, 600);
	ListBox_SetCurSel(hPrList, 0);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Acquire USB device list                                               */
/*----------------------------------------------------------------------------*/
static BOOL OnClickDevice(HWND hDlg)
{
	HWND		hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	SXUSBDEVICE	sxdev[MAX_DEVICE];
	DWORD		i, j, dwReaded, dwReturned, dwIp;
	TCHAR		szBuf[4096], szIp[64];
	LPBYTE		lpbIpAddr;
	int			iIpAddrlen;

	ZeroMemory(gsxdev, (sizeof(SXUSBDEVINFO) * MAX_DEVICE));
	ZeroMemory(sxdev, sizeof(sxdev));
	ListBox_ResetContent(hList);

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)
	{
		GetDlgItemText(hDlg, IDC_LIST_PRICOM, szIp, sizeof(szIp));
		if (szIp[0] == '\0')	return (FALSE);
		if ((dwIp = inet_addr(szIp)) == INADDR_NONE)	return (FALSE);
	}
	else
	{
		if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
		{
			lpbIpAddr = gsxsrv[i].bIpAddress;
			iIpAddrlen = sizeof(gsxsrv[i].bIpAddress);

			if(!SxuptpEnumDevicesV6(lpbIpAddr, iIpAddrlen , &sxdev,(sizeof(SXUSBDEVICE) * MAX_DEVICE), &dwReaded, &dwReturned))
				return(FALSE);
		}
		else
		{
			dwIp = gsxsrv[i].dwIp;

			if (!SxuptpEnumDevices(dwIp, &sxdev,(sizeof(SXUSBDEVICE) * MAX_DEVICE), &dwReaded, &dwReturned))
				return (FALSE);
		}
	}

	for (i = 0, j = 0; i < dwReturned; i++)
	{
		lstrcpy(gsxdev[j].szDeviceName, sxdev[i].szDeviceName);
		lstrcpy(gsxdev[j].szLocation, sxdev[i].szLocation);
		lstrcpy(gsxdev[j].szPortName, sxdev[i].szPortName);
		memcpy(gsxdev[j].bIpAddrPc, sxdev[i].bIpAddrPc, 16);
		gsxdev[j].dwIpPc  = sxdev[i].dwIpPc;
		gsxdev[j].wPid    = sxdev[i].wPid;
		gsxdev[j].wVid    = sxdev[i].wVid;
		gsxdev[j].wStatus = sxdev[i].wStatus;
		gsxdev[j].wClass  = sxdev[i].wClass;

		if (!CollectMfpInterface(&gsxdev[j], gsxdev, j))	j++;
	}

	for (i = 0; i < j; i++)
	{
		wsprintf(szBuf, "%s (VID:%04X PID:%04X / %s)",
			gsxdev[i].szDeviceName, gsxdev[i].wVid, gsxdev[i].wPid, gsxdev[i].szLocation);
		ListBox_AddString(hList, szBuf);
	}

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Request screen (client) callback function                             */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY
PasswordProc(
	HWND	hDlg,
	WORD	Msg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	switch (Msg)
	{
	case WM_INITDIALOG:
		SendMessage(GetDlgItem(hDlg, IDC_EDIT_PASSWORD), EM_SETLIMITTEXT, (WPARAM)SXUPTP_PASSWORD, 0);
		break;

	case WM_ENDSESSION:
	case WM_DESTROY:
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDIT_PASSWORD, gszPassword, SXUPTP_PASSWORD+1);
			EndDialog(hDlg, TRUE);
			return (TRUE);

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return (TRUE);
		}
		break;
	}

	return (FALSE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static DWORD ConnectDevice(
	HWND			hDlg,
	LPSXPSERVER		lpsxsrv,
	LPSXUSBDEVINFO	lpsxdev
)
{
	SXUSBDEVICE	sxdev;
	BOOL		bRet = TRUE;
	TCHAR		szPort[SXUPTP_PORT], szLocation[SXUPTP_LOCATION];
	int			ip = 0, il = 0;
	DWORD		dwFlags = 0, dwRet = 0;

	ZeroMemory(gszPassword, sizeof(gszPassword));

	// USB device connect encryption
	if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_ENCRYPTION)) == BST_CHECKED)
		dwFlags |= SVLC_ENCRYPT;

	while (1)
	{
		ip += GetDevString(szPort, &lpsxdev->szPortName[ip]);
		il += GetDevString(szLocation, &lpsxdev->szLocation[il]);

		if (szPort[0] == '\0' || szLocation[0] == '\0')	break;

		lstrcpy(sxdev.szDeviceName, lpsxdev->szDeviceName);
		lstrcpy(sxdev.szLocation, szLocation);
		lstrcpy(sxdev.szPortName, szPort);
		sxdev.dwIpPc = lpsxdev->dwIpPc;
		sxdev.wPid = lpsxdev->wPid;
		sxdev.wVid = lpsxdev->wVid;
		sxdev.wStatus = lpsxdev->wStatus;

		if ((lpsxdev->wStatus & 0x0010) == 0x0010)
		{
			if (DialogBox(hInst, MAKEINTRESOURCE(DLG_PASSWORD), hDlg, (DLGPROC)PasswordProc) == FALSE)
			{
				return (2);
			}

			dwFlags |= SVLC_AUTH;
		}

		if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
		{
			dwRet = SxuptpDeviceConnectV6(
				lpsxsrv->bIpAddress, sizeof(lpsxsrv->bIpAddress), lpsxsrv->bNodeaddr, &sxdev, dwFlags, (LPVOID)gszPassword);
		}
		else
		{
			dwRet = SxuptpDeviceConnectEx2 (
				lpsxsrv->dwIp, lpsxsrv->bNodeaddr, &sxdev, dwFlags, (LPVOID)gszPassword);
		}
	}

	return (dwRet);

}


/*----------------------------------------------------------------------------*/
/*		USB device connection processing                                      */
/*----------------------------------------------------------------------------*/
static BOOL OnClickConnect(HWND hDlg)
{
	HWND	hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND	hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD	dwRet = 0;
	int		i, j;

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);
	if ((j = ListBox_GetCurSel(hList)) == LB_ERR)	return (FALSE);

	dwRet = ConnectDevice(hDlg, &gsxsrv[i], &gsxdev[j]);

	OnClickDevice(hDlg);

	return (dwRet);

}


/*----------------------------------------------------------------------------*/
/*		All USB devices connection processing                                 */
/*----------------------------------------------------------------------------*/
static DWORD OnClickAllConnect(HWND hDlg)
{
	HWND	hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND	hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD	dwRet = 0, dwErrCode = 0;
	int		i, j, iCount;

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);
	iCount = ListBox_GetCount(hList);

	for (j = 0; j < iCount; j++) {
		dwRet = ConnectDevice(hDlg, &gsxsrv[i], &gsxdev[j]);
		if (dwRet != 0)	dwErrCode = dwRet;
	}

	OnClickDevice(hDlg);

	return (dwErrCode);
}


/*----------------------------------------------------------------------------*/
/*		USB device disconnect process                                         */
/*----------------------------------------------------------------------------*/
static BOOL OnClickDisconnect(HWND hDlg)
{
	HWND		hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	SXUSBDEVICE	sxdev;
	TCHAR		szPort[SXUPTP_PORT], szLocation[SXUPTP_LOCATION];
	BOOL		bRet = TRUE;
	int			i, j, ip = 0, il = 0;

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);
	if ((j = ListBox_GetCurSel(hList)) == LB_ERR)	return (FALSE);

	while (1)
	{
		ip += GetDevString(szPort, &gsxdev[j].szPortName[ip]);
		il += GetDevString(szLocation, &gsxdev[j].szLocation[il]);

		if (szPort[0] == '\0' || szLocation[0] == '\0')	break;

		lstrcpy(sxdev.szDeviceName, gsxdev[j].szDeviceName);
		lstrcpy(sxdev.szLocation, szLocation);
		lstrcpy(sxdev.szPortName, szPort);
		sxdev.dwIpPc  = gsxdev[j].dwIpPc;
		sxdev.wPid    = gsxdev[j].wPid;
		sxdev.wVid    = gsxdev[j].wVid;
		sxdev.wStatus = gsxdev[j].wStatus;

		if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
		{
			if (!SxuptpDeviceDisconnectV6(
				gsxsrv[i]. bIpAddress, sizeof(gsxsrv[i]. bIpAddress ), gsxsrv[i].bNodeaddr, &sxdev))
				bRet = FALSE;
		}
		else
		{
			if (!SxuptpDeviceDisconnectEx(gsxsrv[i].dwIp, gsxsrv[i].bNodeaddr, &sxdev))
				bRet = FALSE;
		}
	}

	Sleep(8000);
	OnClickDevice(hDlg);

	return (bRet);

}


/*----------------------------------------------------------------------------*/
/*		All USB devices disconnect process                                    */
/*----------------------------------------------------------------------------*/
static BOOL OnClickAllDisconnect(HWND hDlg)
{
	HWND		hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	SXUSBDEVICE	sxdev;
	TCHAR		szPort[SXUPTP_PORT], szLocation[SXUPTP_LOCATION];
	BOOL		bRet = TRUE;
	int			i, j, ip = 0, il = 0, iCount;

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);
	iCount = ListBox_GetCount(hList);

	for (j = 0; j < iCount; j++)
	{
		ip = il = 0;

		while (1)
		{
			ip += GetDevString(szPort, &gsxdev[j].szPortName[ip]);
			il += GetDevString(szLocation, &gsxdev[j].szLocation[il]);

			if (szPort[0] == '\0' || szLocation[0] == '\0')	break;

			lstrcpy(sxdev.szDeviceName, gsxdev[j].szDeviceName);
			lstrcpy(sxdev.szLocation, szLocation);
			lstrcpy(sxdev.szPortName, szPort);
			sxdev.dwIpPc  = gsxdev[j].dwIpPc;
			sxdev.wPid    = gsxdev[j].wPid;
			sxdev.wVid    = gsxdev[j].wVid;
			sxdev.wStatus = gsxdev[j].wStatus;

			if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
			{
				if (!SxuptpDeviceDisconnectV6(
					gsxsrv[i]. bIpAddress, sizeof(gsxsrv[i]. bIpAddress ), gsxsrv[i].bNodeaddr, &sxdev))
					bRet = FALSE;
			}
			else
			{
				if (!SxuptpDeviceDisconnectEx(gsxsrv[i].dwIp, gsxsrv[i].bNodeaddr, &sxdev))
					bRet = FALSE;
			}
		}
	}

	Sleep(8000);
	OnClickDevice(hDlg);

	return (bRet);

}


/*----------------------------------------------------------------------------*/
/*		Status acquisition processing                                         */
/*----------------------------------------------------------------------------*/
static BOOL OnClickStatus(HWND hDlg)
{
	HWND	hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND	hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD	i, j, ip = 0, dwStatus, len;
	TCHAR	szPort[SXUPTP_PORT], szBuf[512];

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);
	if ((j = ListBox_GetCurSel(hList)) == LB_ERR)	return (FALSE);

	len = wsprintf(szBuf, "Status : ");

	while (1)
	{
		ip += GetDevString(szPort, &gsxdev[j].szPortName[ip]);
		if (szPort[0] == '\0')	break;

		if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
		{
			dwStatus = SxuptpGetDeviceStatusV6(
				gsxsrv[i].bIpAddress, sizeof(gsxsrv[i].bIpAddress), szPort);
			len += wsprintf((szBuf + len), "%d ", dwStatus);
		}
		else
		{
			dwStatus = SxuptpGetDeviceStatus(gsxsrv[i].dwIp, szPort);
			len += wsprintf((szBuf + len), "%d ", dwStatus);
		}
	}

	MessageBox(hDlg, szBuf, "SXUPTP", MB_OK | MB_ICONINFORMATION);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Reboot device server processing                                       */
/*----------------------------------------------------------------------------*/
static BOOL OnClickReboot(HWND hDlg)
{
	HWND	hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD	i;

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);

	if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
		return (SxuptpRebootDeviceServerV6(gsxsrv[i].bIpAddress, 16, gsxsrv[i].bNodeaddr));
	else
		return (SxuptpRebootDeviceServer(gsxsrv[i].dwIp, gsxsrv[i].bNodeaddr));

}


/*----------------------------------------------------------------------------*/
/*		System Status acquisition processing                                  */
/*----------------------------------------------------------------------------*/
static BOOL OnClickSystem(HWND hDlg)
{
	HWND	hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD	i;
	char	szBuf[4096];

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);

	ZeroMemory(szBuf, sizeof(szBuf));
	if (!SxuptpGetSystemStatus(gsxsrv[i].dwIp, szBuf, sizeof(szBuf)))	return (FALSE);

	MessageBox(hDlg, szBuf, "SXUPTP", MB_OK | MB_ICONINFORMATION);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Server information acquisition processing                             */
/*----------------------------------------------------------------------------*/
static BOOL OnClickServer(HWND hDlg)
{
	SXPSERVER	sxsrv;
	HWND		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	DWORD		i;
	TCHAR		szBuf[256], szIp[16], szAddr[256], szMac[32];

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (FALSE);

	if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
	{
		if (!SxuptpGetDeviceServerInfoV6(
			gsxsrv[i].bIpAddress, sizeof(gsxsrv[i].bIpAddress), &sxsrv, sizeof(SXPSERVER)))
			return (FALSE);
	}
	else
	{
		if (!SxuptpGetDeviceServerInfo(gsxsrv[i].dwIp, &sxsrv, sizeof(SXPSERVER)))
			return (FALSE);
	}

	MyAddressToString(szIp, _countof(szIp), (LPBYTE)&gsxsrv[i].dwIp, 4);
	MyAddressToString(szAddr, _countof(szAddr), gsxsrv[i].bIpAddress, 16);

	wsprintf(szMac, "%02X:%02X:%02X:%02X:%02X:%02X",
		sxsrv.bNodeaddr[0], sxsrv.bNodeaddr[1],
		sxsrv.bNodeaddr[2], sxsrv.bNodeaddr[3],
		sxsrv.bNodeaddr[4], sxsrv.bNodeaddr[5]
	);
	wsprintf(szBuf, "%s (%s / %s / %s / %s)",
		sxsrv.szMachineType, szIp, szAddr, sxsrv.szHostName, szMac);
	MessageBox(hDlg, szBuf, "SXUPTP", MB_OK | MB_ICONINFORMATION);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Request screen (server) callback function                             */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY ServerProc(
   	HWND	hDlg,
	WORD	Msg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	switch (Msg)
	{
	case WM_INITDIALOG:
		{
			LPSRUINFO	pSruInfo = (LPSRUINFO)lParam;
			TCHAR		szMsg[2048];
			int			iOffset;

			SetDlgItemText(hDlg, IDC_STC_MSG, "A request was received...");

			iOffset = wsprintf(szMsg, "Message: %d\r\n", pSruInfo->wMessage);
			iOffset += wsprintf(szMsg + iOffset, "Device: %s\r\n", pSruInfo->szDeviceName);
			iOffset += wsprintf(szMsg + iOffset, "Dest: %s\r\n", pSruInfo->szDestName);
			SetDlgItemText(hDlg, IDC_STC_INFO, szMsg);
		}
		break;

	case WM_ENDSESSION:
	case WM_DESTROY:
		ghMsgWnd = NULL;

		EnableWindow(GetParent(hDlg), TRUE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDCANCEL:
			SruRefuseRequest();
			DestroyWindow(hDlg);
			return (TRUE);

		case IDC_BTN_YES:
			EnableWindow(GetDlgItem(hDlg, IDC_BTN_YES), FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_BTN_NO), FALSE);
			SetDlgItemText(hDlg, IDC_STC_MSG, "Accepted to request...");

			SruAcceptRequest();

			if (!OnClickDisconnect(GetParent(hDlg)))
			{
				SruDeviceNotFound();
				return (TRUE);
			}

			SruDisconnectedDevice();
			DestroyWindow(hDlg);
			return (TRUE);

		case IDC_BTN_NO:
			SruRefuseRequest();
			DestroyWindow(hDlg);
			return (TRUE);
		}
		break;
	}

	return (FALSE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static BOOL ServerMessage(
	HWND	hDlg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	LPSRUINFO		pSruInfo = (LPSRUINFO)wParam;
	SXUSBDEVINFO	sxdev;
	HWND			hList, hPrList;
	DWORD			dwDevCount;
	TCHAR			szMsg[2048], szTime[256];
	int				i, iIndex, iOffset;

	switch (pSruInfo->wMessage)
	{
	case SRU_REQUEST:		// USB foCXgpv
		if (IsWindow(ghMsgWnd))	DestroyWindow(ghMsgWnd);

		hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);

		if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)				return (FALSE);
		if (memcmp(gsxsrv[i].bNodeaddr, pSruInfo->bNodeaddr, 6))	return (FALSE);

		if (pSruInfo->iSrvIpAddlen == 16) {
			if (memcmp(gsxsrv[i].bIpAddress, pSruInfo->bSrvIpAddr, 16))	return (FALSE);
		}
		else {
			if (memcmp(&gsxsrv[i].dwIp, pSruInfo->bSrvIpAddr, 4))		return (FALSE);
		}

		dwDevCount = ListBox_GetCount(GetDlgItem(hDlg, IDC_LIST_DEVICE));
		ZeroMemory(&sxdev, sizeof(sxdev));
		lstrcpy(sxdev.szDeviceName, pSruInfo->szDeviceName);
		lstrcpy(sxdev.szLocation, pSruInfo->szLocation);
		sxdev.wPid = pSruInfo->wPid;
		sxdev.wVid = pSruInfo->wVid;

		iIndex = CompareDevice(&sxdev, gsxdev, dwDevCount);
		if (iIndex == -1)	return (FALSE);

		if (ConvConnectStatus(&gsxdev[iIndex]) != STATUS_CONNECTED)	return (FALSE);

		ListBox_SetCurSel(hList, iIndex);

#if 1
		SruSendReply(1, 30);
#else
		SruSendReply(0, 0);
#endif

		memcpy(&gSruInfo, pSruInfo, sizeof(SRUINFO));
		ghMsgWnd = CreateDialogParam(hInst,
			MAKEINTRESOURCE(DLG_SERVER), hDlg, (DLGPROC)ServerProc, (LPARAM)pSruInfo);
		ShowWindow(ghMsgWnd, SW_SHOW);

		EnableWindow(hDlg, FALSE);
		break;

	case SRU_CANCEL:		// gpvLZ
		if (IsWindow(ghMsgWnd))	DestroyWindow(ghMsgWnd);
		break;

	case SRU_CONFIRM:
		hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);

		if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)				return (FALSE);
		if (memcmp(gsxsrv[i].bNodeaddr, pSruInfo->bNodeaddr, 6))	return (FALSE);

		if (pSruInfo->iSrvIpAddlen == 16) {
			if (memcmp(gsxsrv[i].bIpAddress, pSruInfo->bSrvIpAddr, 16))	return (FALSE);
		}
		else {
			if (memcmp(&gsxsrv[i].dwIp, pSruInfo->bSrvIpAddr, 4))		return (FALSE);
		}

		dwDevCount = ListBox_GetCount(GetDlgItem(hDlg, IDC_LIST_DEVICE));
		ZeroMemory(&sxdev, sizeof(sxdev));
		lstrcpy(sxdev.szDeviceName, pSruInfo->szDeviceName);
		lstrcpy(sxdev.szLocation, pSruInfo->szLocation);
		sxdev.wPid = pSruInfo->wPid;
		sxdev.wVid = pSruInfo->wVid;

		iIndex = CompareDevice(&sxdev, gsxdev, dwDevCount);
		if (iIndex == -1)	return (FALSE);

		if (ConvConnectStatus(&gsxdev[iIndex]) != STATUS_CONNECTED)	return (FALSE);

		ListBox_SetCurSel(hList, iIndex);
		break;

	case SRU_DISCONTIME:	// ؒf܂ł̎cԗv
		iOffset = wsprintf(szMsg, "Message: %d\r\n", pSruInfo->wMessage);
		iOffset += wsprintf(szMsg + iOffset, "Device: %s\r\n", pSruInfo->szDeviceName);
		iOffset += wsprintf(szMsg + iOffset, "Dest: %s\r\n", pSruInfo->szDestName);
		SetDlgItemText(ghMsgWnd, IDC_STC_INFO, szMsg);

		wsprintf(szTime, "%d sec until auto-disconnect.", pSruInfo->dwRemainingTime);
		SetDlgItemText(ghMsgWnd, IDC_STC_TIMER, szTime);

		if (pSruInfo->dwRemainingTime == 0)
		{
			PostMessage(ghMsgWnd, WM_COMMAND,
				MAKEWPARAM(IDC_BTN_YES, BN_CLICKED), (LPARAM)GetDlgItem(ghMsgWnd, IDC_BTN_YES));
		}
		break;
	}

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static HANDLE DoRequestUse(HWND hDlg)
{
	HWND		hParent = GetParent(hDlg);
	HWND		hList = GetDlgItem(hParent, IDC_LIST_DEVICE);
	HWND		hPrList = GetDlgItem(hParent, IDC_LIST_PRICOM);
	HANDLE		hHandle;
	SXUSBDEVICE	sxdev;
	TCHAR		szPort[SXUPTP_PORT], szLocation[SXUPTP_LOCATION];
	int			i, j;

	SetDlgItemText(hDlg, IDC_STC_MSG, "Send request use...");

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (NULL);
	if ((j = ListBox_GetCurSel(hList)) == LB_ERR)	return (NULL);

	if (ConvConnectStatus(&gsxdev[j]) != STATUS_INUSE)	return (NULL);

	GetDevString(szPort, gsxdev[j].szPortName);
	GetDevString(szLocation, gsxdev[j].szLocation);

	lstrcpy(sxdev.szDeviceName, gsxdev[j].szDeviceName);
	lstrcpy(sxdev.szLocation, szLocation);
	lstrcpy(sxdev.szPortName, szPort);
	memcpy(sxdev.bIpAddrPc, gsxdev[j].bIpAddrPc, 16);
	sxdev.dwIpPc  = gsxdev[j].dwIpPc;
	sxdev.wPid    = gsxdev[j].wPid;
	sxdev.wVid    = gsxdev[j].wVid;
	sxdev.wStatus = gsxdev[j].wStatus;

	if (Button_GetCheck(GetDlgItem(hParent, IDC_CHECK_USEV6)) == BST_CHECKED)
		hHandle = SruSendRequestV6(hDlg, (LPBYTE)&gsxsrv[i].bIpAddress, 16, gsxsrv[i].bNodeaddr, &sxdev, 5);
	else
		hHandle = SruSendRequest(hDlg, gsxsrv[i].dwIp, gsxsrv[i].bNodeaddr, &sxdev, 5);

	return (hHandle);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static BOOL ClientMessage(
	HWND	hDlg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	LPSRUINFO	pSruInfo = (LPSRUINFO)wParam;
	TCHAR		szMsg[2048], szTime[512];
	int			iOffset;

	iOffset = wsprintf(szMsg, "Message: %d\r\n", pSruInfo->wMessage);
	iOffset += wsprintf(szMsg + iOffset, "Device: %s\r\n", pSruInfo->szDeviceName);
	iOffset += wsprintf(szMsg + iOffset, "Dest: %s\r\n", pSruInfo->szDestName);
	SetDlgItemText(hDlg, IDC_STC_INFO, szMsg);

	switch (pSruInfo->wMessage)
	{
	case SRU_ACCEPT:			// gpvt
		SetDlgItemText(hDlg, IDC_STC_MSG, "The request was accepted.");
		break;

	case SRU_REFUSE:			// gpv
		SetDlgItemText(hDlg, IDC_STC_MSG, "The request was refused. Request use again?");

		EnableWindow(GetDlgItem(hDlg, IDC_BTN_YES), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_BTN_NO), TRUE);
		break;

	case SRU_DISCONNECT:		// ؒf
		SetDlgItemText(hDlg, IDC_STC_MSG, "The device has been disconnected");

		OnClickConnect(GetParent(hDlg));
		EndDialog(hDlg, TRUE);
		break;

	case SRU_BUSY:				// ҂Ɖb
		SetDlgItemText(hDlg, IDC_STC_MSG, "Talking to someone else. Request use again?");

		EnableWindow(GetDlgItem(hDlg, IDC_BTN_YES), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_BTN_NO), TRUE);
		break;

	case SRU_REPLY:				// gpv̎M
		SetDlgItemText(hDlg, IDC_STC_MSG, "Waiting for the response of the request.");
		break;

	case SRU_REPLYEX:			// M(ؒfL)
		SetDlgItemText(hDlg, IDC_STC_MSG, "Waiting for the response of the request.");

		wsprintf(szTime, "%d sec until auto-disconnect.", pSruInfo->dwRemainingTime);
		SetDlgItemText(hDlg, IDC_STC_TIMER, szTime);
		break;

	case SRU_NOTFOUND:			// USB foCXȂ
		wsprintf(szMsg, "%s is not found.", pSruInfo->szDeviceName);
		SetDlgItemText(hDlg, IDC_STC_MSG, szMsg);
		break;

	case SRU_DISCONTIME:		// ؒf܂ł̎cԉ
		wsprintf(szTime, "%d sec until auto-disconnect.", pSruInfo->dwRemainingTime);
		SetDlgItemText(hDlg, IDC_STC_TIMER, szTime);
		break;

	case SRU_TIMEOUT:
		SetDlgItemText(hDlg, IDC_STC_MSG, "There was no reply. Request use again?");

		EnableWindow(GetDlgItem(hDlg, IDC_BTN_YES), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_BTN_NO), TRUE);
		break;
	}

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		Request screen (client) callback function                             */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY ClientProc(
   	HWND	hDlg,
	WORD	Msg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	static HANDLE	hRequest = NULL;

	switch (Msg)
	{
	case WM_INITDIALOG:
		hRequest = DoRequestUse(hDlg);
		if (hRequest == NULL)	EndDialog(hDlg, FALSE);
		break;

	case WM_ENDSESSION:
	case WM_DESTROY:
		SruCloseHandle(hRequest);
		hRequest = NULL;
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDCANCEL:
			SruCancelRequest(hRequest);
			EndDialog(hDlg, LOWORD(wParam));
			return (TRUE);

		case IDC_BTN_YES:
			EnableWindow(GetDlgItem(hDlg, IDC_BTN_YES), FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_BTN_NO), FALSE);
			SetDlgItemText(hDlg, IDC_STC_MSG, "Send request use...");

			SruCancelRequest(hRequest);
			hRequest = DoRequestUse(hDlg);
			return (TRUE);

		case IDC_BTN_NO:
			EndDialog(hDlg, LOWORD(wParam));
			return (TRUE);
		}
		break;

	case SRU_NOTIFY:
		return (ClientMessage(hDlg, wParam, lParam));
	}

	return (FALSE);

}


/*----------------------------------------------------------------------------*/
/*		Request use processing                                                */
/*----------------------------------------------------------------------------*/
static VOID OnClickRequest(HWND hDlg)
{
	DialogBox(hInst, MAKEINTRESOURCE(DLG_CLIENT), hDlg, (DLGPROC)ClientProc);
}


/*----------------------------------------------------------------------------*/
/*		Get Instatnce ID processing                                           */
/*----------------------------------------------------------------------------*/
static BOOL OnClickInstanceId(HWND hDlg)
{
	LPSXDEVINST	lpdevinst = NULL;
	HWND		hList = GetDlgItem(hDlg, IDC_LIST_DEVICE);
	HWND		hPrList = GetDlgItem(hDlg, IDC_LIST_PRICOM);
	int			i, j, dwCount;

	if ((i = ListBox_GetCurSel(hPrList)) == CB_ERR)	return (NULL);
	if ((j = ListBox_GetCurSel(hList)) == LB_ERR)	return (NULL);

	if (Button_GetCheck(GetDlgItem(hDlg, IDC_CHECK_USEV6)) == BST_CHECKED)
		dwCount = SxuptpGetInstanceIdV6(gsxsrv[i].bIpAddress, 16, gsxdev[j].szLocation, &lpdevinst);
	else
		dwCount = SxuptpGetInstanceId(gsxsrv[i].dwIp, gsxdev[j].szLocation, &lpdevinst);

	if (dwCount == 0)	return (FALSE);

	for (i = 0; i < dwCount; i++)
		MessageBox(hDlg, (lpdevinst + i)->lpszInstanceId, "SXUPTP", MB_OK | MB_ICONINFORMATION);

	SxuptpFreeInstanceId(lpdevinst);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		                                                                      */
/*----------------------------------------------------------------------------*/
static VOID CheckUsbDeviseStatus(HWND hDlg)
{
	int i;

	if (i = ListBox_GetCurSel(GetDlgItem(hDlg, IDC_LIST_DEVICE)) == LB_ERR)	return;

	Button_SetCheck(GetDlgItem(hDlg, IDC_CHECK_ENCRYPTION), BST_UNCHECKED );

	if (gsxdev[i].wStatus & 0x1000)
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_ENCRYPTION), TRUE);
	else
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_ENCRYPTION), FALSE);

	return;
}


/*----------------------------------------------------------------------------*/
/*		Main screen callback function                                         */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY DlgProc(
	HWND	hDlg,
	WORD	Msg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	DWORD	dwError;
	BOOL	bRes;
	TCHAR	szErrMes[256];

	switch (Msg)
	{
	case WM_INITDIALOG:
		{
			DWORD	dwSize;
			TCHAR	szPath[MAX_PATH + 1], szName[MAX_COMPUTERNAME_LENGTH + 1];
			int		iRuleNo;

			SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)hMainIcon);

			GetCurDir(szPath);
			lstrcat(szPath, "\\Sample.ini");

			iRuleNo = GetPrivateProfileInt("SETTINGS", "RULENO", 0, szPath);
			if (iRuleNo != 0)	SxuptpSetSrchRuleCookie(iRuleNo);

			dwSize = sizeof(szName);
			GetComputerName(szName, &dwSize);
			SruInitialize(hInst, hDlg, szName);
		}
		return (TRUE);

	case WM_ENDSESSION:
	case WM_DESTROY:
		SruUninitialize(hInst);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return (TRUE);

		case IDC_CMB_PRICOM:
			if (HIWORD(wParam) == CBN_SELENDOK) {
				ListBox_ResetContent(GetDlgItem(hDlg, IDC_LIST_DEVICE));
			}
			return (TRUE);

		case IDC_LIST_DEVICE:
			if (HIWORD(wParam) == LBN_SELCHANGE) {
				CheckUsbDeviseStatus(hDlg);
			}
			return (TRUE);

		case IDC_BTN_SEARCH:
			if (!OnClickSearch(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_DEVICE:
			if (!OnClickDevice(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_CONNECT:
			dwError = OnClickConnect(hDlg);
			if (dwError != 0)
			{
				wsprintf(szErrMes, "SXUPTP : %02d", dwError);
				MessageBox(hDlg, szErrMes, "Failed.", MB_OK | MB_ICONEXCLAMATION);
			}				
			return (TRUE);

		case IDC_BTN_ACONNECT:
			dwError = OnClickAllConnect(hDlg);
			if (dwError != 0)
			{
				wsprintf(szErrMes, "Failed : %02d", dwError);
				MessageBox(hDlg, szErrMes, "Failed.", MB_OK | MB_ICONEXCLAMATION);
			}
			return (TRUE);

		case IDC_BTN_DISCONNECT:
			if (!OnClickDisconnect(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_ADISCONNECT:
			if (!OnClickAllDisconnect(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_STATUS:
			if (!OnClickStatus(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_REBOOT:
			if (!OnClickReboot(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_SYSTEM:
			if (!OnClickSystem(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_SERVER:
			if (!OnClickServer(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);

		case IDC_BTN_REQUEST:
			OnClickRequest(hDlg);
			return (TRUE);

		case IDC_BTN_INSTID:
			if (!OnClickInstanceId(hDlg))
				MessageBox(hDlg, "SXUPTP", "Failed.", MB_OK | MB_ICONEXCLAMATION);
			return (TRUE);
		}
		break;

	case SRU_NOTIFY:
		bRes = ServerMessage(hDlg, wParam, lParam);
		SetWindowLongPtr(hDlg, DWLP_MSGRESULT, bRes);
		return (TRUE);
	}

	return (FALSE);

}
