/*******************************************************************************
*                                                                              *
*	SXUPTP sample program                                                      *
*                                                                              *
*   silex technology, Inc. CONFIDENTIAL                                        *
*                                                                              *
*----------+---------+---------------------------------------------------------*
*   Date   | Version |                        Content                          *
*----------+---------+---------------------------------------------------------*
* 07-01-15 |  1.0.0  |                                                         *
*----------+---------+---------------------------------------------------------*
*******************************************************************************/
#include <windows.h>

#include "sample.h"


/*----------------------------------------------------------------------------*/
/*		Constant definition                                                   */
/*----------------------------------------------------------------------------*/
LPCSTR	glpszClassName = "STI SXUPTP SAMPLE";


/*----------------------------------------------------------------------------*/
/*		Variable definition                                                   */
/*----------------------------------------------------------------------------*/
HINSTANCE	hInst = NULL;
HICON		hMainIcon = NULL;


/*----------------------------------------------------------------------------*/
/*		Window Main processing                                                */
/*----------------------------------------------------------------------------*/
int APIENTRY WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPSTR		lpCmdLine,
	int			nCmdShow
)
{
	HWND	hWnd;

	// Verify single occurrence of application.
	HANDLE hMutex = CreateMutex(NULL, TRUE, glpszClassName);
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		hWnd = FindWindow(glpszClassName, NULL);
		if (hWnd)
		{
			if (IsIconic(hWnd))	ShowWindow(hWnd, SW_RESTORE);
			SetForegroundWindow(hWnd);
		}
		return (FALSE);
	}

	// Save the instance.
	hInst = hInstance;

	// Load the icon.
	hMainIcon = (HICON)LoadImage(hInst,
		MAKEINTRESOURCE(IDI_MAIN), IMAGE_ICON, 16, 16, 0);

	// Check the language and display correct dialog box.
	if (GetSystemDefaultLangID() == 1041)
		DialogBox(hInst, MAKEINTRESOURCE(DLG_MAIN), NULL, (DLGPROC)DlgProc);
	else
		DialogBox(hInst, MAKEINTRESOURCE(DLG_MAIN_ENG), NULL, (DLGPROC)DlgProc);

	// Free resource.
	DestroyIcon(hMainIcon);

	return (TRUE);

}
